#!/usr/local/bin/perl 

$| = 1;

# Copyright (c) 2007 The Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#   1. Redistributions of source code must retain the above copyright
#      notice, this list of conditions, and the following disclaimer.
#   2. Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions, and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
#   3. Redistributions must acknowledge that this software was
#      originally developed by the UCSF Computer Graphics Laboratory
#      under support by the NIH National Center for Research Resources,
#      grant P41-RR01081.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
# OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
# OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
# EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#change TMPDIR to the complete directory path for your tmp3 location
$TMPDIR = "/usr/tmp/open";
#change topo2run to your complete directory path to the TOPO2 python
#source code on your server
$topo2run = "/usr/local/src/www/sacs/htdocs/TOPO2/cgi-bin";
$topow = "$topo2run/topo2.py";
$topops = "$topo2run/topops.py";
$topopng = "$topo2run/topoparser.py";

$usage = "None";
$good_usage = "None";
$error = "None";
# if logging of TOPO2 attempts is desired, put # before the prior three
# lines and then remove the # from the following lines and replace 
# logging_dir with the name of the complete directory path for the your 
# logs. If you use the same names for your logs as given here, you won't 
# need to any other changes further down in the script. 
#$logging_dir = "/home/socr/a/johns/open-topo2";
#$usage = "$logging_dir/topo2.usage";
#$good_usage = "$logging_dir/topo2-good.usage";
#$error = "$logging_dir/topo2.errors";

# NO CHANGES SHOULD BE NEEDED BEYONG THIS POINT
#=======================================================================

use LWP::Simple;
use CGI qw(:all);
use CGI::Carp qw(fatalsToBrowser);

$analyze = new CGI;

##draw form for submission of database sequence searching
print $analyze->header();
print $analyze->start_html( -title=>'TOPO2', -bgcolor=>'#99ffcc');
print $analyze->h2("TOPO2 Results"),p;


#get the date information
system("date +%a%d%b%T >$TMPDIR/timestamp");
open (CKS,"$TMPDIR/timestamp");
while (<CKS>){
  $now = $_;
   last;
}

$day = substr($now,0,3);
$daynum = substr($now,3,2);
$month = substr($now,5,3);
$time = substr($now,8,8);
$rundate = join(" ","$day","$month","$daynum");

$line2 = join(" ","Used","$time","on","$rundate");
$remote_host = $ENV{'REMOTE_HOST'};
$remote_addr = $ENV{'REMOTE_ADDR'};
$line = join(" ","$remote_host","(","$remote_addr",")");
$line3 = join(" ","$line2","by","$line");
$track = join(" ","$line3","-","error");

if ($usage ne "None"){
#print off usage line
open (USAGE,">>$usage");
print USAGE "$line3\n";
close (USAGE);
}

#section to see if this directory exists and if not create it
if(-d $TMPDIR){
}else{
   open (MAKE, "|mkdir $TMPDIR");
   close MAKE;
}

##give each query sequence a unique name
if (param('seqid')){
        $seqnam = param('seqid');
        $seqnam =~ s/\s+//g; 
        $seqid = $seqnam."_$$"; 
}else{
	$seqid = "seqid"."_$$";
}

##make sure form is properly filled out
if (param('sequence')&&param('sequencefile')){
	print h3("Enter a sequence to work with."),p;
	if ($error ne "None"){
	        open (ERROR,">>$error");
		$lie = join(" ","$seqid","error - no sequence to work with");
		print ERROR "$track\n";
		print ERROR "   $lie\n";
		close (ERROR);
        }
	exit;
}elsif(param('sequence')){
	$sequence = param('sequence');
	@seqparts = split(' ',$sequence);
	$seqlogs = @seqparts + 0;
	if($seqlogs == 0){
  	   print h3("Enter a sequence to work with - there is only white space."),p;
	   if ($error ne "None"){
	           open (ERROR,">>$error");
		   $lie = join(" ","$seqid","error - only white space to work with");
		   print ERROR "$track\n";
		   print ERROR "   $lie\n";
		   close (ERROR);
	   }
	   exit;
	}
}elsif(param('sequencefile')){
	$sequence = param('sequencefile');
}else{
	print h3("Enter a sequence to work with."),p;
	if ($error ne "None"){
	        open (ERROR,">>$error");
		$lie = join(" ","$seqid","error - no sequence to work with -2");
	        print ERROR "$track\n";
		print ERROR "   $lie\n";
		close (ERROR);
	}
	exit;
}

#create a working area for this data
open (MAKE, "|mkdir $TMPDIR/$seqid");
close MAKE;

# Decide what input type to use. Paste in sequence or Accession number.
#$seqtype = param('seqtype');

if (param('seqtype') eq 'pastein'){

        $sequence =~ tr/a-zA-Z//cd;
        $sequence =~ tr/a-z/A-Z/;
        #write out sequence file for reformatting
        open (SEQFILE, ">$TMPDIR/$seqid/$seqid");
        print SEQFILE ">..\n$sequence\n";
        close (SEQFILE);
## check for nucleotide sequences
        $long = length($sequence);
        $j = 0;
        $ct_a = 0;
        $ct_c = 0;
        $ct_g = 0;
        $ct_n = 0;
        $ct_t = 0;
        $ct_u = 0;
        while ($j < $long){
           $spot = substr($sequence,$j,1);
           if($spot eq "A"){
              $ct_a = $ct_a + 1;
           }elsif($spot eq "C"){
              $ct_c = $ct_c +1;
           }elsif($spot eq "G"){
              $ct_g = $ct_g +1;
           }elsif($spot eq "N"){
              $ct_n = $ct_n +1;
           }elsif($spot eq "T"){
              $ct_t = $ct_t +1;
           }elsif($spot eq "U"){
              $ct_u = $ct_u +1;
           }
           $j = $j + 1;
        }
        $sum = $ct_a + $ct_c + $ct_g + $ct_n + $ct_t + $ct_u;
        if ($sum > .9*$long){
           print "\n<h3>TOPO2 is for the displaying of protein information. Please retry with a protein sequence.</h3>\n";
           `rm -r -f $TMPDIR/$seqid`;
 	   if ($error ne "None"){
	           open (ERROR,">>$error");
		   $lie = join(" ","$seqid","error - nucleotide sequence tried");
	           print ERROR "$track\n";
		   print ERROR "   $lie\n";
		   close (ERROR);
           }
	   exit;
        }
}else{
 	$url="http://www.ncbi.nlm.nih.gov/htbin-post/Entrez/query?db=p&form=6&Dopt=f&html=no&uid=$sequence";

        @entry = split(/\n/,(get $url));

    if ($entry[2] =~/^Entrez Reports/ ||
        $entry[0] =~/^ERROR/) {

        print "$sequence ERROR";

        print "\n<tt><pre>$url</tt></pre>\n";
        `rm -r -f $TMPDIR/$seqid`;
        print "\n<h3>ERROR - $sequence not found at NCBI</h3>\n";
	if ($error ne "None"){
	        open (ERROR,">>$error");
		$lie = join(" ","$seqid","error - no sequence to work with faulty GI or accession -3");
	        print ERROR "$track\n";
		print ERROR "   $lie\n";
		close (ERROR);
	}
	exit;
  }else {
	open (SEQFILE, ">$TMPDIR/$seqid/$seqid");
        $have_gt = 0;
        for $l (@entry) {
            if ($l=~/^>/) {$have_gt = 1;}
            if ($have_gt == 1) { print SEQFILE "$l\n";}
        }
        close (SEQFILE);

## check for size of the sequence file
        `ls -la $TMPDIR/$seqid/$seqid > $TMPDIR/$seqid/check1`;
        open (CHECKS,"$TMPDIR/$seqid/check1");
        while (<CHECKS>){
           $cline = $_;
	   $howbig_ck = substr($cline,33,7);
	   $bigs_ck = $howbig_ck;
        }
        if($bigs_ck == 0){
           print h3("There was a problem with the sequence download."),p;
           print h3("Try again!"),p;
           `rm -r -f $TMPDIR/$seqid`;
  	   if ($error ne "None"){
	           open (ERROR,">>$error");
		   $lie = join(" ","$seqid","error - download problem");
	           print ERROR "$track\n";
		   print ERROR "   $lie\n";
		   close (ERROR);
           }
	   exit;
        }
 
	open (SEQFILE, "$TMPDIR/$seqid/$seqid");
	open (SEQFILE2, ">$TMPDIR/$seqid/$seqid-x");
	$i = 1;
	while (<SEQFILE>){
	   if($i == 1){
	      $line = ">"."$seqid"." sequence from database";
	      print SEQFILE2 "$line\n";
	      $i = $i + 1;
	   }else{
	      print SEQFILE2 "$_\n";
	   }
	}
        close (SEQFILE);
        close (SEQFILE2);
    }
}

##create file names dependent on the $seqid variable
$toposcript = join ("-","$seqid","toposcript");
$topoparms = join ("-","$seqid","topoparms");

## write out counter and printing variables
$count = param('count');

##get other variables from form (part 1)
$nsegs = param('inum');
if($nsegs == 0){
   print h3("TOPO2 does not predict transmembrane segments!");
   $what = "The user needs to supply the number and locations of such"; 
   $what1 = "segments in the submission form.";
   print h4("$what");
   print h4("$what1");

   print "&nbsp;&nbsp;&nbsp;See the help page for running 
",a({href=>'/TOPO2/topo2-help.html'},'TOPO2.'),p;
   print h3("Try again!"),p;
   `rm -r -f $TMPDIR/$seqid`;
   if ($error ne "None"){
	   open (ERROR,">>$error");
	   $lie = join(" ","$seqid","error - segment number not supplied");
	   print ERROR "$track\n";
	   print ERROR "   $lie\n";
	   close (ERROR);
   }
   exit;
}

$begin = 1;
$end = $num;
$size = param('size');
$seqtype = param('seqtype');

## working with segments data
$segs = param('segs');
@parts = ();
@parts = split(' ',$segs);
$logs = @parts + 0;
if($logs == 0){
   print h3("TOPO2 does not predict transmembrane segments!");
   $what = "The user needs to supply the number and locations of such"; 
   $what1 = "segments in the submission form.";
   print h4("$what");
   print h4("$what1");

   print "&nbsp;&nbsp;&nbsp;See the help page for running ",a({href=>'/TOPO2/topo2-help.html'},'TOPO2.'),p;
   print h3("Try again!"),p;
   `rm -r -f $TMPDIR/$seqid`;
   if ($error ne "None"){
	open (ERROR,">>$error");
	$lie = join(" ","$seqid","error - segment lines not supplied");
	print ERROR "$track\n";
	print ERROR "   $lie\n";
	close (ERROR);
   }
   exit;
}

$times = $logs/3;
$inum = 0; 
if($times != $nsegs){
   print h3("The number of desired segments and segments line information do not match!");
   $what0 = "The segments box contains "."$nsegs"." and there are "."$times"." lines in the segments window.";
   $what = "&nbsp;&nbsp;&nbsp;The segments box contains "."$nsegs"." and there are "."$times"." lines in the segments window.";
   print h4("$what");
   $down_one = $nsegs - 1;
   if($down_one < $times && $times < $nsegs){
      $what2 = "&nbsp;&nbsp;&nbsp;Each line in the segments window should contain 3 numbers.";
      $what3 = "&nbsp;&nbsp;&nbsp;Such lines should end in either 1 or 2.";
      print h4("$what2");
      print h4("$what3");
      while($inum < $times){
          $outline = join(" ","$parts[3*$inum]","$parts[3*$inum+1]","$parts[3*$inum+2]");;
          print "&nbsp;&nbsp;&nbsp;$outline",br;
          $inum = $inum + 1;
      }
      print h4(" ");
   }
   print "&nbsp;&nbsp;&nbsp;See information for running this process ",a({href=>'/TOPO2/topo2-help.html#number'},'here.'),p;
   print h3("Try again!"),p;
   `rm -r -f $TMPDIR/$seqid`;
   if ($error ne "None"){
	open (ERROR,">>$error");
	$lie = join(" ","$seqid","error - number of segments and segment lines do not match");
	print ERROR "$track\n";
	print ERROR "   $lie\n";
	print ERROR "   $what0\n";
	close (ERROR);
   }
   exit;
}
## check to see that end of transmembrane segment is bigger than start
$i = 0;
while ($i < $times){
   $fck = $parts[3*$i];
   $mck = $parts[3*$i+1];
   $tck = $parts[3*$i+2];
   if ($fck > $mck){
       print h3("The transmembrane segment ending point is smaller than its beginning one"),p; 
       $segline = "beginning is "."$fck"." and ending is "."$mck";
       print h3("$segline"),p;
       print h3("Try again!"),p;
       `rm -r -f $TMPDIR/$seqid`;
       if ($error ne "None"){
	       open (ERROR,">>$error");
	       $lie = join(" ","$seqid","error - TMD end smaller than start");
	       print ERROR "$track\n";
	       print ERROR "   $lie\n";
	       print ERROR "   $seqline\n";
	       close (ERROR);
       }
       exit;
   }
## check to see if the segments are too small or too large for the program
   $longcheck = $mck - $fck;
   if ($longcheck < 5){
       print h3("The transmembrane segment is too small for the program"),p; 
       if ($tck == 1){
          print h3("Acceptable range is 6-42 full"),p;
       }else{ 
          print h3("Acceptable range is 6-79 partial"),p;
       } 
       $segline = "beginning is "."$fck"." and ending is "."$mck";
       print h3("$segline"),p;
       print h3("Try again!"),p;
       `rm -r -f $TMPDIR/$seqid`;
       if ($error ne "None"){
	       open (ERROR,">>$error");
	       $lie = join(" ","$seqid","error - TMD too small");
	       print ERROR "$track\n";
	       print ERROR "   $lie\n";
	       print ERROR "   $seqline\n";
	       close (ERROR);
       }
       exit;
   }
   if($tck == 1){
      if($longcheck > 42){
          print h3("The transmembrane segment is too large for the program"),p; 
          print h3("Acceptable range is 6-42 full"),p;
          $segline = "beginning is "."$fck"." and ending is "."$mck";
          print h3("$segline"),p;
          print h3("Try again!"),p;
          `rm -r -f $TMPDIR/$seqid`;
          if ($error ne "None"){
             open (ERROR,">>$error");
             $lie = join(" ","$seqid","error - TMD regular too large");
             print ERROR "$track\n";
             print ERROR "   $lie\n";
             print ERROR "   $seqline\n";
             close (ERROR);
          }
          exit;
      }
   }elsif($tck == 2){ 
      if($longcheck > 78){
          print h3("The transmembrane segment is too large for the program"),p; 
          print h3("Acceptable range is 6-79 partial"),p;
          $segline = "beginning is "."$fck"." and ending is "."$mck";
          print h3("$segline"),p;
          print h3("Try again!"),p;
          `rm -r -f $TMPDIR/$seqid`;
          if ($error ne "None"){
             open (ERROR,">>$error");
             $lie = join(" ","$seqid","error - TMD partial too large");
             print ERROR "$track\n";
             print ERROR "   $lie\n";
             print ERROR "   $seqline\n";
             close (ERROR);
          }
          exit;
      }
   }
   $i = $i +1;
}
## check to see that segments are in sequential order and don't overlap
$i = 0;
while ( $i < $times -1){
   $endf = $parts[3*$i + 1];
   $frontn = $parts[3*($i+1)];
   if ($endf == $frontn){
          print h3("The transmembrane segments overlap"),p;
          $istart0 = $i + 1; 
          $istart1 = $i + 2; 
          $segline = "end of segment("."$istart0".") is "."$endf"." and the beginning of segment("."$istart1".") is "."$frontn";
          print h3("$segline"),p;
          print h3("Try again!"),p;
          `rm -r -f $TMPDIR/$seqid`;
          if ($error ne "None"){
            open (ERROR,">>$error");
            $lie = join(" ","$seqid","error - TMD overlap");
             print ERROR "$track\n";
             print ERROR "   $lie\n";
             print ERROR "   $segline\n";
             close (ERROR);
          }
          exit;
   }
   $i = $i + 1;
}
$where_s = param('where_start');
if($where_s eq 'outside'){
   $where_start = 1;
}elsif($where_s eq 'inside'){
   $where_start = 2;
}

if(param('show_outside') eq '1'){
   $show_outside = 'y';
}else{
   $show_outside = 'n';
}

if(param('show_cys') eq '1'){
   $show_cys = 'y';
}else{
   $show_cys = 'n';
}
$cys_sym = param('cys_sym');
$cys_col = param('cys_col');

if(param('show_gly') eq '1'){
   $show_gly = 'y';
}else{
   $show_gly = 'n';
}
$gly_sym = param('gly_sym');
$gly_col = param('gly_col');

if(param('show_mem') eq '1'){
   $show_membrane = 'y';
}else{
   $show_membrane = 'n';
}

if(param('show_ch') eq '1'){
   $show_charged = 'y';
}else{
   $show_charged = 'n';
}
$acid_sym = param('acid_sym');
$acid_col = param('acid_col');

$base_sym = param('base_sym');
if($base_sym < 0 || $base_sym > 5){
   $base_symline = "The basic residue symbol number given is beyond acceptable range (0-5)";
   print h3("$base_symline"),p;
   print h3("Try again!"),p;
   `rm -r -f $TMPDIR/$seqid`;
   if ($error ne "None"){
      open (ERROR,">>$error");
      $lie = join(" ","$seqid","error - basic residue symbol number out of range");
      print ERROR "$track\n";
      print ERROR "   $lie\n";
      close (ERROR);
   } 
   exit;
}   
$base_col = param('base_col');

if(param('show_amine') eq '1'){
   $show_amine = 'y';
}else{
   $show_amine = 'n';
}

$amine_sym = param('amine_sym');
$amine_col = param('amine_col');

if(param('show_oh') eq '1'){
   $show_OH = 'y';
}else{
   $show_OH = 'n';
}

$OH_sym = param('oh_sym');
$OH_col = param('oh_col');

if(param('show_arom') eq '1'){
   $show_aromatic = 'y';
}else{
   $show_aromatic = 'n';
}
$aromatic_sym = param('arom_sym');
$aromatic_col = param('arom_col');

if(param('show_pro') eq '1'){
   $show_proline = 'y';
}else{
   $show_proline = 'n';
}
$proline_sym = param('pro_sym');
$proline_col = param('pro_col');

if(param('show_sign') eq '1'){
   $show_signature = 'y';
}else{
   $show_signature = 'n';
}
$nsign = param('signum');
## working with signature data
$regions = param('regions');
@sigparts = ();
@sigparts = split(' ',$regions);
$siglogs = @sigparts + 0;
$sigtimes = $siglogs/4;
$insig = 0;
if($sigtimes != $nsign){
   print h3("The number of desired signature regions and signature lines information do not match!");
   $what0 = "The signature box contains "."$nsign"." and there are "."$sigtimes"." lines in the signature window.";
   $what = "&nbsp;&nbsp;&nbsp;The signature box contains "."$nsign"." and there are "."$sigtimes"." lines in the signature window.";
   print h4("$what");
   $down_two = $nsign - 1;
   if($down_two < $sigtimes && $sigtimes < $nsign){
       print h4("&nbsp;&nbsp;&nbsp;There should be 4 items on each line.");
       print h4("&nbsp;&nbsp;&nbsp;Each line should end with a supported color.");
       while ($insig < $nsign){
           $outlinesign = join(" ","$sigparts[4*$insig]","$sigparts[4*$insig+1]","$sigparts[4*$insig+2]","$sigparts[4*$insig+3]");
           print "&nbsp;&nbsp;&nbsp;$outlinesign",br;
           $insig = $insig + 1;
       }
       print h4(" \n");
   }    
   print "&nbsp;&nbsp;&nbsp;See information for running this process ",a({href=>'/TOPO2/topo2-help.html#sign'},'here.'),p;
   print h3("Try Again!");
   `rm -r -f $TMPDIR/$seqid`;
   if ($error ne "None"){
      open (ERROR,">>$error");
      $lie = join(" ","$seqid","error - number of desired signature regions and signature lines do not match");
      print ERROR "$track\n";
      print ERROR "   $lie\n";
      print ERROR "   $what0\n";
      close (ERROR);
   }
   exit;
}
## check for symbols being out of range
$insig = 0;
while($insig < $nsign){
   if($sigpart[4*$insig+2] < 0 || $sigpart[4*$insig+2] > 5){
      $place = $insig + 1;
      print h3("The symbol used for signature region $place is beyond acceptable range (0-5)"); 
      print h3("Try Again!");
      `rm -r -f $TMPDIR/$seqid`;
      if ($error ne "None"){
         open (ERROR,">>$error");
         $lie = join(" ","$seqid","error - signature symbol out of range");
         print ERROR "$track\n";
         print ERROR "   $lie\n";
         close (ERROR);
         }
      exit;
   }
   $insig = $insig + 1;
}
## check for colors being supported
$insig = 0;
$colok = 0;
while($insig < $nsign){
   $insig2 = $insig + 1;
   $colchk = $sigparts[4*$insig+3];
   if($colchk eq "white"){
      $colok = 0;
   }elsif($colchk eq "black"){
      $colok = 0;
   }elsif($colchk eq "red"){
      $colok = 0;
   }elsif($colchk eq "orange"){
      $colok = 0;
   }elsif($colchk eq "blue"){
      $colok = 0;
   }elsif($colchk eq "cyan"){
      $colok = 0;
   }elsif($colchk eq "green"){
      $colok = 0;
   }elsif($colchk eq "yellow"){
      $colok = 0;
   }elsif($colchk eq "magenta"){
      $colok = 0;
   }elsif($colchk eq "purple"){
      $colok = 0;
   }else{
      $colok = 1;
   }
   if($colok == 1){
      print h3("The color ($colchk) used for signature region $insig2 is not supported."); 
      print h3("Check a pull down menu for supported colors."); 
      print h3("Try Again!");
      `rm -r -f $TMPDIR/$seqid`;
      if ($error ne "None"){
         open (ERROR,">>$error");
         $lie = join(" ","$seqid","error - signature color not supported");
         print ERROR "$track\n";
         print ERROR "   $lie\n";
         close (ERROR);
      }
      exit;
   }
   $insig = $insig + 1;
}

if(param('show_sp') eq '1'){
   $show_special = 'y';
}else{
   $show_special = 'n';
}
$nspecial = param('spnum');
## working with special data
$special = param('special');
@spparts = ();
@spparts = split(' ',$special);
$splogs = @spparts + 0;
$sptimes = $splogs/3;
$insp = 0;
if($sptimes != $nspecial){
   $what0= "Number of desired special residues and special lines information do not match";
   print h3("$what0");
   $what = "&nbsp;&nbsp;&nbsp;The special box contains "."$nspecial"." and there are "."$sptimes"." lines in the special window.";
   $whats = "The special box contains "."$nspecial"." and there are "."$sptimes"." lines in the special window.";
   print h4("$what");
   $down_three = $nspecial -1;
   if($down_three < $sptimes && $sptimes < $nspecial){
      print h4("&nbsp;&nbsp;&nbsp;There should be 3 items on each line.");
      print h4("&nbsp;&nbsp;&nbsp;Each line should end in a supported color.");
      while ($insp < $nspecial){
          $outlinesp = join(" ","$spparts[3*$insp]","$spparts[3*$insp+1]","$spparts[3*$insp+2]");
          print "&nbsp;&nbsp;&nbsp;$outlinesp",br;
          $insp = $insp + 1;
      }
      print h4(" \n");
   }
   print "&nbsp;&nbsp;&nbsp;See information for running this process ",a({href=>'/TOPO2/topo2-help.html#special'},'here.'),p;

   print h3("Try Again!");
   `rm -r -f $TMPDIR/$seqid`;
   if ($error ne "None"){
      open (ERROR,">>$error");
      $lie = join(" ","$seqid","error - number of desired special residues and residue lines do not match");
      print ERROR "$track\n";
      print ERROR "   $lie\n";
      print ERROR "   $whats\n";
      close (ERROR);
   }
   exit;
}

## check for symbols being out of range
$insp = 0;
while($insp < $nspecial){
   if($spparts[3*$insp+1] < 0 || $spparts[3*$insp+1] > 5){
      $place = $insp + 1;
      print h3("The symbol used for special region $place is beyond acceptable range (0-5)"); 
      print h3("Try Again!");
      `rm -r -f $TMPDIR/$seqid`;
      if ($error ne "None"){
         open (ERROR,">>$error");
         $lie = join(" ","$seqid","error - special symbol out of range");
         print ERROR "$track\n";
         print ERROR "   $lie\n";
         close (ERROR);
      }
      exit;
   }
   $insp = $insp + 1;
}
## check for colors being supported
$insp = 0;
$colok = 0;
while($insp < $nspecial){
   $insp2 = $insp + 1;
   $colchk = $spparts[3*$insp+2];
   if($colchk eq "white"){
      $colok = 0;
   }elsif($colchk eq "black"){
      $colok = 0;
   }elsif($colchk eq "red"){
      $colok = 0;
   }elsif($colchk eq "orange"){
      $colok = 0;
   }elsif($colchk eq "blue"){
      $colok = 0;
   }elsif($colchk eq "cyan"){
      $colok = 0;
   }elsif($colchk eq "green"){
      $colok = 0;
   }elsif($colchk eq "yellow"){
      $colok = 0;
   }elsif($colchk eq "magenta"){
      $colok = 0;
   }elsif($colchk eq "purple"){
      $colok = 0;
   }else{
      $colok = 1;
   }
   if($colok == 1){
      print h3("The color ($colchk) used for special region $insp2 is not supported."); 
      print h3("Check a pull down menu for supported colors."); 
      print h3("Try Again!");
      `rm -r -f $TMPDIR/$seqid`;
      if ($error ne "None"){
         open (ERROR,">>$error");
         $lie = join(" ","$seqid","error - special color not supported");
         print ERROR "$track\n";
         print ERROR "   $lie\n";
         close (ERROR);
      }
      exit;
   }
   $insp = $insp + 1;
}

## write out parameters to a file
open (STUFF, ">$TMPDIR/$seqid/$topoparms")|| die "couldn't open parms: ";
if($seqtype eq 'pastein'){
   $namex = "$TMPDIR/$seqid/$seqid";
}elsif($seqtype eq 'accession'){
   $namex = "$TMPDIR/$seqid/$seqid-x";
}
## write out parameters to a file
open (STUFF, ">$TMPDIR/$seqid/$topoparms")|| die "couldn't open parms: ";

## first input line (sequence, num of segments, where starts, title
$lix = join("\t","$namex","$nsegs","$where_start","UNKNOWN");
print STUFF "$lix\n";

## data for the segments
$i = 0;
while ($i < $times){
   $f = $parts[3*$i];
   $m = $parts[3*$i+1];
   $b = $parts[3*$i+2];
   if ($b eq '1' || $b eq '2'){
       $lix = join("\t","$f","$m","$b");
       print STUFF "$lix\n";
   }else{
       print h3("The transmembrane type is neither a 1 or a 2 in one of the lines!");
       close (STUFF);
       `rm -r -f $TMPDIR/$seqid`;
       if ($error ne "None"){
          open (ERROR,">>$error");
          $lie = join(" ","$seqid","error - transmembrane type is wrong");
          print ERROR "$track\n";
          print ERROR "   $lie\n";
          close (ERROR);
       }
       exit;
   }
   $i = $i +1;
}

## external colorations
if ($show_outside ne 'n'){
   if ($show_cys eq 'n' && $show_gly eq 'n'){
       print h3("Outside residue coloring selected, but no shape or color choosen");
       close (STUFF);
       `rm -r -f $TMPDIR/$seqid`;
       if ($error ne "None"){
          open (ERROR,">>$error");
          $lie = join(" ","$seqid","error - no outside residue shape or color choosen");
          print ERROR "$track\n";
          print ERROR "   $lie\n";
          close (ERROR);
       }
       exit;
   }
   if ($show_cys ne 'n'){
      $f = join("\t","$show_cys","$cys_sym","$cys_col");
   }else{
      $f = "n";
   }

   if ($show_gly ne 'n'){
      $b = join("\t","$show_gly","$gly_sym","$gly_col");
   }else{
      $b = "n";
   }
   $ext = join("\t","$show_outside","$f","$b");
}else{
   $ext = $show_outside;
}
print STUFF "$ext\n";

## membrane colorations
if($show_membrane ne 'n'){
   if ($show_charged eq 'n' && $show_amine eq 'n' && $show_OH eq 'n' && $show_aromatic eq 'n' && $show_proline eq 'n'){
       print h3("Membrane residue coloring selected, but no shapes or colors choosen");
       close (STUFF);
       `rm -r -f $TMPDIR/$seqid`;
       if ($error ne "None"){
          open (ERROR,">>$error");
          $lie = join(" ","$seqid","error - no membrane residue shapes or colors choosen");
          print ERROR "$track\n";
          print ERROR "   $lie\n";
          close (ERROR);
       }
       exit;
   }
   if($show_charged ne 'n'){
      $ch = join("\t","$show_charged","$acid_sym","$acid_col","$base_sym","$base_col");
   }else{
      $ch = "n";
   }
   if($show_amine ne 'n'){
      $am = join("\t","$show_amine","$amine_sym","$amine_col");
   }else{
      $am = "n";
   }
   if($show_OH ne 'n'){
      $oh = join("\t","$show_OH","$OH_sym","$OH_col");
   }else{
      $oh = "n";
   }
   if($show_aromatic ne 'n'){
      $arom = join("\t","$show_aromatic","$aromatic_sym","$aromatic_col");
   }else{
      $arom = "n";
   }
   if($show_proline ne 'n'){
      $pro = join("\t","$show_proline","$proline_sym","$proline_col");
   }else{
      $pro = "n";
   }
   $mems = join("\t","$show_membrane","$ch","$am","$oh","$arom","$pro");
}else{
   $mems = "$show_membrane";
}
print STUFF "$mems\n";

## signature colorations
## data for the signatures
if ($show_signature ne 'n') {
    $slix = join("\t","$show_signature","$nsign","@sigparts");
    print STUFF "$slix\n";
}else{
   print STUFF "$show_signature\n";
}

## special colorations
## data for the special residues
if ($show_special ne 'n') {
    $splix = join("\t","$show_special","$nspecial","@spparts");
    print STUFF "$splix\n";
}else{
   print STUFF "$show_special\n";
}
print STUFF "n\n";
close(STUFF);

####
#check the parameter file for real segment data lines
$para_count = 0;
open (STUFF2, "$TMPDIR/$seqid/$topoparms")|| die "couldn't open parms: ";
while (<STUFF2>){
   $para_count = $para_count + 1;
}
close (STUFF2);
#print "there are $para_count segment lines";

if($para_count <= 5){
   print h3("There are no segment data lines!");
   close (STUFF);
   `rm -r -f $TMPDIR/$seqid`;
   if ($error ne "None"){
      open (ERROR,">>$error");
      $lie = join(" ","$seqid","error - no segment data lines 2");
      print ERROR "$track\n";
      print ERROR "   $lie\n";
      close (ERROR);
    }
    exit;
}   

##postscript output for downloading

## check for displaying of residue characters
$show_res = param('show_res');
## write out csh script file
$outstopo6 = 'test.png';
$outstopo = join(".","$seqid","xml");
$outstopo2 = join(".","$seqid","ps");
$outstopo5 = "$outstopo2"."-2";
if($nsegs > 0 && $show_res eq 'yes'){
   open (SCRIPT, ">$TMPDIR/$seqid/$toposcript");
   print SCRIPT <<"END OF SCRIPT";
setenv HOME $TMPDIR/$seqid
cd $TMPDIR/$seqid
$topow  -o $TMPDIR/$seqid/$outstopo $TMPDIR/$seqid/$topoparms
$topops -o $TMPDIR/$seqid/$outstopo2 $TMPDIR/$seqid/$outstopo
$topopng $TMPDIR/$seqid/$outstopo 
END OF SCRIPT
   close (SCRIPT);
}elsif($nsegs > 0 && $show_res eq 'no'){
   open (SCRIPT, ">$TMPDIR/$seqid/$toposcript");
   print SCRIPT <<"END OF SCRIPT";
setenv HOME $TMPDIR/$seqid
cd $TMPDIR/$seqid
$topow  -n -o $TMPDIR/$seqid/$outstopo $TMPDIR/$seqid/$topoparms
$topops -o $TMPDIR/$seqid/$outstopo2 $TMPDIR/$seqid/$outstopo
$topopng $TMPDIR/$seqid/$outstopo 
END OF SCRIPT
   close (SCRIPT);
}

##run CSH script
system ("/bin/csh $TMPDIR/$seqid/$toposcript");
`wait 10`;

#check to see what sort of image output was created
`ls  $TMPDIR/$seqid/$outstopo6 > $TMPDIR/$seqid/img-hit`;
$imgct = 0;
open (IMGCHECK,"$TMPDIR/$seqid/img-hit");
while (<IMGCHECK>){
    $imgct = $imgct + 1;
}
close (IMGCHECK);

   p;
   print "<hr>";
   print "<b>TOPO2 image of submitted data.</b>",p;
   p;
   if($imgct > 0){
	   print "<img src=\"/tmp3/$seqid/test.png\"><p>";
   }else{
	   print "<img src=\"/tmp3/$seqid/test.gif\"><p>";
   }
   p;
   print " ",a({href=>"/tmp3/$seqid/$outstopo2"},'postscript data file'),p;

p;

#check to see all went well
`ls  $TMPDIR/$seqid/*.ps > $TMPDIR/$seqid/ps-hit`;
$psct = 0;
open (PSCHECK,"$TMPDIR/$seqid/ps-hit");
while (<PSCHECK>){
    $psct = $psct + 1;
}
close (PSCHECK);

if($psct > 0){
##check for ending part of ps file
   $ends = 0;
   `grep showpage $TMPDIR/$seqid/*.ps > $TMPDIR/$seqid/ends`;
   open (ENDING,"$TMPDIR/$seqid/ends");
   while (<ENDING>){
      $ends = $ends + 1;
   }
   close (ENDING);
#check the size of the output file
   if($ends > 0){
      `ls -la $TMPDIR/$seqid/*.ps > $TMPDIR/$seqid/size`;
       open (BIG,"$TMPDIR/$seqid/size");
       while (<BIG>){
          $sline = $_;
          $howbig = substr($sline,33,7);
          $bigs = $howbig;
       }
   }
   if($ends > 0 && $bigs >4999){
#print off  good usage line
        if ($good_usage ne "None"){
		open (USAGEG,">>$good_usage");
		print USAGEG "$line3\n";
		close (USAGEG);
	}
#clean up un-necessary files
      `rm -f $TMPDIR/$seqid/$seqid`;
      `rm -f $TMPDIR/$seqid/$seqid-t*`;
      `rm -f $TMPDIR/$seqid/$seqid.xml`;
      `rm -f $TMPDIR/$seqid/img-hit`;
      `rm -f $TMPDIR/$seqid/ps-hit`;
      `rm -f $TMPDIR/$seqid/ends`;
      `rm -f $TMPDIR/$seqid/size`;
      if($seqtype ne 'pastein'){
         `rm -f $TMPDIR/$seqid/$seqid-x`;
      }
   }elsif($ends > 0 && $bigs < 5000){
       if ($error ne "None"){
          open (ERROR,">>$error");
          $lie = join(" ","$seqid","something may be weird - ps file too small ("."$bigs".")");
          print ERROR "$track\n";
          print ERROR "   $lie\n";
          close (ERROR);
       }
   }elsif($ends == 0){
       if ($error ne "None"){
          open (ERROR,">>$error");
          $lie = join(" ","$seqid","something did not work - missing showpage");
          print ERROR "$track\n";
          print ERROR "   $lie\n";
          close (ERROR);
       }
   }
}else{
   if ($error ne "None"){
      open (ERROR,">>$error");
      $lie = join(" ","$seqid","something did not work - check it out");
      print ERROR "$track\n";
      print ERROR "   $lie\n";
      close (ERROR);
   }
}
1;

####
print "   ","\n";
p;
print hr();
p;
print  "Sometimes clicking on the browser BACK button will return you to the
submission page with your data intact.",p;

print $analyze->end_html;

