# Copyright (c) 2007 The Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#   1. Redistributions of source code must retain the above copyright
#      notice, this list of conditions, and the following disclaimer.
#   2. Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions, and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
#   3. Redistributions must acknowledge that this software was
#      originally developed by the UCSF Computer Graphics Laboratory
#      under support by the NIH National Center for Research Resources,
#      grant P41-RR01081.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
# OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
# OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
# EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import string

def reverse(s):
	long = len(s)
	i = 0
	sez = ''
	while i <= long -1:
		log = long -i -1
		spot = s[log:log+1]
		sez = sez + spot
		i = i + 1
	return sez

def layer_data(O,i,S,R,y,factor):
	num = S
	if O == 1:
		if i == 0:
			num = S + 1
	elif O == 2:
		if i == 0 or i == 2:
			num = S + 1
	elif O == 3:
		if i == 0 or i == 2 or i == 4:
			num = S + 1
	elif O == 4:
		if i == 0 or i == 1 or i == 2 or i == 4:
			num = S + 1
	elif O == 5:
		if i != 5:
			num = S + 1

	if num == 1:
		incy = R
		ystart = y
	elif num == 2:
		incy = R
		ystart = y + .5*R*factor
	elif num == 3:
		incy = .5*R
		ystart = y + incy*factor
	elif num == 4:
		incy = .25*R
		ystart = y + 2*incy*factor
	elif num == 5:
		incy = .25*R
		ystart = y + 2*incy*factor
	elif num == 6:
		incy = .25*R
		ystart = y + 3*incy*factor
	elif num == 7:
		incy = .25*R
		ystart = y + 3*incy*factor
	
	return(num,incy,ystart)

def memcolors(l2,r):
	l5 = 1
	l6 = 'x'
	if r.memdo == 'y':
		if r.chdo == 'y':
			if l2 == 'D' or l2 == 'E':
				l5 = r.acidsym
				l6 = r.acidcol
			if l2 == 'H' or l2 == 'K' or l2 == 'R':
				l5 = r.basesym
				l6 = r.basecol
		if r.amdo == 'y':
			if l2 == 'N' or l2 == 'Q':
				l5 = r.amsym
				l6 = r.amcol
		if r.ohdo == 'y':
			if l2 == 'S' or l2 == 'T' or l2 == 'Y':
				l5 = r.ohsym
				l6 = r.ohcol
		if r.aromdo == 'y':
			if l2 == 'F' or l2 == 'Y' or l2 == 'W':
				l5 = r.aromsym
				l6 = r.aromcol
		if r.prodo == 'y':
			if l2 == 'P':
				l5 = r.prosym
				l6 = r.procol

	return(l5,l6)

def colors(l6):
	cols = []
	if l6 == "x":
		c = "0 0 0"
		cols.append(c)
		c = "1 1 1"
		cols.append(c)
		c = "0 0 0"
		cols.append(c)
	elif l6 == "white":
		c = "0 0 0"
		cols.append(c)
		c = "1 1 1"
		cols.append(c)
		c = "0 0 0"
		cols.append(c)
        elif l6 == "yellow":
		c = "1 1 1"
		cols.append(c)
		c = "1 1 0"
		cols.append(c)
		c = "1 1 0"
		cols.append(c)
	elif l6 == "orange":
		c = "1 1 1"
		cols.append(c)
		c = "1 .5 0"
		cols.append(c)
		c = "1 .5 0"
		cols.append(c)
	elif l6 == "red":
		c = "1 1 1"
		cols.append(c)
		c = "1 0 0"
		cols.append(c)
		c = "1 0 0"
		cols.append(c)
	elif l6 == "green":
		c = "1 1 1"
		cols.append(c)
		c = "0 1 0"
		cols.append(c)
		c = "0 1 0"
		cols.append(c)
	elif l6 == "cyan":
		c = "1 1 1"
		cols.append(c)
		c = "0 1 1"
		cols.append(c)
		c = "0 1 1"
		cols.append(c)
	elif l6 == "magenta":
		c = "1 1 1"
		cols.append(c)
		c = "1 0 1"
		cols.append(c)
		c = "1 0 1"
		cols.append(c)
	elif l6 == "blue":
		c = "1 1 1"
		cols.append(c)
		c = "0 0 1"
		cols.append(c)
		c = "0 0 1"
		cols.append(c)
	elif l6 == "purple":
		c = "1 1 1"
		cols.append(c)
		c = ".5 0 1"
		cols.append(c)
		c = ".5 0 1"
		cols.append(c)
	elif l6 == "black":
		c = "1 1 1"
		cols.append(c)
		c = "0 0 0"
		cols.append(c)
		c = "0 0 0"
		cols.append(c)

	return cols

def printVerbose(verbose,msg):
	if verbose == 1:
		print msg

	return
